/******************************************************************************
 *  SiteBar XUL - A Firefox sidebar for the SiteBar Bookmark Server.          *
 *  Copyright (C) 2003,2004  Bas Burger																				*
 *	<http://knowledge-emporium.com/forum/index.php?styleid=18> 					      *
 *                                                                            *
 *  This program is free software; you can redistribute it and/or modify      *
 *  it under the terms of the GNU General Public License as published by      *
 *  the Free Software Foundation; either version 2 of the License, or         *
 *  (at your option) any later version.                                       *
 *                                                                            *
 *  This program is distributed in the hope that it will be useful,           *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU General Public License for more details.                              *
 *                                                                            *
 *  You should have received a copy of the GNU General Public License         *
 *  along with this program; if not, write to the Free Software               *
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
 ******************************************************************************/

var sitebar_keyboardShortcutsConfigured = false;
var sitebar_sidebarWidthConfigured = false;
var sitebar_sidebarHostConfigured = false;

// initialize these event listners to be able to bind shortcuts
// and other settings to the main overlay.
window.removeEventListener("load", sitebar_overlayinit, true);
window.addEventListener("load", sitebar_overlayinit, true);

/* Small Buttons ------------------------------------------------------*/

function sitebar_reloadFrame()
{
		const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
		var sbfrm = document.getElementById("sitebarFrame");
		var hostname = preferencesService.getCharPref("sitebar.host.sidebar.address");
		var href = hostname + 'sitebar.php';

  	// reload SiteBar in sidebar frame.
  	urlSecurityCheck(href, document);
  	sbfrm.setAttribute("src", href);
}

function sitebar_addPage()
{
		const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
		var w = window;
		var d = w.content.document;
		var cp = d.characterSet ? d.characterSet : d.charset;
		
		var hostname = preferencesService.getCharPref("sitebar.host.sidebar.address");
		var href = hostname + 'command.php?command=Add%20Link&name=' + escape(d.title) + '&url=' + escape(w.content.location.href) + '&cp=' + cp;
		var href2 = hostname + 'command.php?command=Add%20Link&name=' + escape(d.title) + '&url=' + escape(w.content.location.href) + (cp?'&cp='+cp:'');

		// If the view in windows/tab preference is set to true
    if(preferencesService.prefHasUserValue("sitebar.view.source.tab") && preferencesService.getBoolPref("sitebar.view.source.tab"))
    {
				// If the open in windows preference is set to true
		    if(preferencesService.prefHasUserValue("sitebar.open.windows") && preferencesService.getBoolPref("sitebar.open.windows"))
		    {
		    		// load in popup.
		    		urlSecurityCheck(href, document);
		        return window.open(href,'sbBmkWin','resizable=yes,dependent=yes,width=210,height=360,top=200,left=300,titlebar=yes,scrollbars=yes');
		    }
		    else
		    {
        		//var browser = top.document.getElementById('content');
        		//var newTab = browser.addTab(address);

        		//browser.selectedTab = newTab;
        		openNewTabWith(href, href, null, true);
		    }

		}
    else
    {
    			var sbfrm = document.getElementById("sitebarFrame");
    			
    			// load in sidebar frame.
    			urlSecurityCheck(href2, document);
  				sbfrm.setAttribute("src", href2);
		}

}

/* mouseclick event handling -----------------------------------------------*/

function sitebar_openSiteBarTabs(event, img)
{
    var frame = document.getElementById('sitebarFrame');
    var base = frame.getAttribute('src');
    var parent = event.target.parentNode.parentNode;

    if (img)
    {
        parent = parent.parentNode;
    }

    var id = 'c' + parent.id;
    var childrenDIV = frame.contentDocument.getElementById(id);
    var obsolete = false;

    if (!childrenDIV)
    {
        obsolete = true;
        id = 'c' + parent.id.substr(1);
        childrenDIV = frame.contentDocument.getElementById(id);
    }

    var children = childrenDIV.childNodes;

    for (var i=0; i<children.length; i++)
    {
        var child = children[i];

        // Each DIV with link has just one link and its ID starts with l
        if (child.className=='link')
        {
            var href = '';

            if (obsolete)
            {
                links = child.getElementsByTagName('a');
                href = links[0].getAttribute('href');
            }
            else
            {
                linkAnchor = frame.contentDocument.getElementById('a'+child.id);
                href = linkAnchor.getAttribute('href');
            }

            if (href.indexOf('javascript:')!=0)
            {
                var fullHREF = makeURLAbsolute(base, href);
                var eventCopy = event;
                openNewTabWith(fullHREF, fullHREF, eventCopy, true);
            }
        }
    }
}

function sitebar_openLinkInTab(event)
{
		const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);
		
    var frame = document.getElementById('sitebarFrame');
    var base = frame.getAttribute('src');
    
    var href = event.target.getAttribute('href');

		var loadInBackground = true;

    if (href.indexOf('javascript:')!=0)
    {
       var fullHREF = makeURLAbsolute(base, href);
			 
			 // Check if load in BG is on and set it off to focus to the added tab.
			 if (preferencesService.getBoolPref("browser.tabs.loadInBackground")) {
			 		preferencesService.setBoolPref("browser.tabs.loadInBackground", false);
			 		loadInBackground = false;
			 }
			 
       openNewTabWith(fullHREF, null, null, true);
       
       // Did we change the preference? if yes restore to it.
       if (!loadInBackground) {
			 		preferencesService.setBoolPref("browser.tabs.loadInBackground", true);
			 }
    }
}

function sitebar_handleSiteBarClick(event)
{
		const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
    var id = event.target.id;

		switch (event.button) {                                   
    	case 0: // Left button.
    		if((id.substr(0,2) == 'al') &&
    			 (preferencesService.prefHasUserValue("sitebar.links.sidebar.lbut") && preferencesService.getBoolPref("sitebar.links.sidebar.lbut"))) {
    				sitebar_openLinkInTab(event);
    				event.preventDefault();
    				// Warning: left button needs false instead of true to
    				// stop event bubble and tell the event has been handled.
    				return false;
    		}
    		else { // if option is off let event bubble up.
    		
    				// Warning: left button needs true instead of false to
    				// tell the event must be handled further.
    			return true;
    		}
    	case 1: // Middle button.
    		if((id.charAt(0) == 'n' || id.substr(0,2) == 'in' || id.substr(0,2) == 'an') &&
    			(preferencesService.prefHasUserValue("sitebar.links.sidebar.mbut") && preferencesService.getBoolPref("sitebar.links.sidebar.mbut"))) {
    			
    			sitebar_openSiteBarTabs(event, (id.substr(0,2) == 'in'));
    			event.preventDefault();
    			// return true to stop event bubble and tell the event has been handled.
    			return true;
    		}
    		else { // if option is off do nothing further.
    		
    			// return true to stop event bubble and tell the event has been handled.
    			return true;
    		}
    	case 2: // right button.
    		return contentAreaClick(event);
    }
    // return false to tell the event must be handled further.
    return false;

}

/* initialize ----------------------------------------------------------------*/

// Configure the keyboard shortcuts
function sitebar_configureKeyboardShortcuts()
{
    // If the keyboard shortcuts have not been configured
    if(!sitebar_keyboardShortcutsConfigured)
    {
        const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

        var key = document.getElementById("keyopensitebarSidebar");

        // If the sidebar key exists
        if(key)
        {
        		sitebar_keyboardShortcutsConfigured = true;
        		
            // If the sidebar key preference is set
            if(preferencesService.prefHasUserValue("sitebar.key.sidebar"))
            {
                key.setAttribute("key", preferencesService.getCharPref("sitebar.key.sidebar"));
            }
            else
            {
                preferencesService.setCharPref("sitebar.key.sidebar", key.getAttribute("key"));
            }
        }

        key = document.getElementById("keyaddpageSidebar");

        // If the validate HTML key exists
        if(key)
        {
            // If the validate HTML key preference is set
            if(preferencesService.prefHasUserValue("sitebar.key.addpage"))
            {
                key.setAttribute("key", preferencesService.getCharPref("sitebar.key.addpage"));
            }
            else
            {
                preferencesService.setCharPref("sitebar.key.addpage", key.getAttribute("key"));
            }
        }
    }
}


// Changes the options
function sitebar_changeOptions()
{
    sitebar_configureKeyboardShortcuts();
    sitebar_initialize();
}

// Displays the options dialog
function sitebar_options()
{
    window.openDialog("chrome://sitebar/content/options/options.xul", "webdeveloper-options-dialog", "centerscreen,chrome,modal");

    sitebar_changeOptions();
}

// Displays the about dialog
function sitebar_about()
{
    window.openDialog("chrome://sitebar/content/about/about.xul", "sitebar-about-dialog", "centerscreen,chrome,modal");
}

// Loads the extension home page in a new tab
function sitebar_visitHome()
{
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    const url                = "http://www.sitebar.org/";

    // If the open in windows preference is set to true
    if(preferencesService.prefHasUserValue("sitebar.open.windows") && preferencesService.getBoolPref("sitebar.open.windows"))
    {
        return window.open(url);
    }
    else
    {
        var browser = top.document.getElementById('content');
        var newTab = browser.addTab(url);

        browser.selectedTab = newTab;
    }

}

function sitebar_initialize()
{

		const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		var sidebar = document.getElementById("ce-main");
    
		// If the sidebar width have not been configured
    if(!sitebar_sidebarWidthConfigured)
    {
				
				if (sidebar)
				{
						sitebar_sidebarWidthConfigured = true;
						
				    // Set the width of the sidebar according the options box.
				    if(preferencesService.prefHasUserValue("sitebar.resize.sidebar.width"))
				    {
				        sidebar.setAttribute("width", preferencesService.getIntPref("sitebar.resize.sidebar.width"));
				    }
				    else
				    {
				    		preferencesService.setIntPref("sitebar.resize.sidebar.width", sidebar.getAttribute("width"));
				    }
		    }
    }
    
    // If the sidebar host have not been configured
    if(!sitebar_sidebarHostConfigured)
    {
		    
		    var sidebarFrame = document.getElementById("sitebarFrame");
		    
				if (sidebarFrame)
				{
						sitebar_sidebarHostConfigured = true;
						
				    // Set the width of the sidebar according the options box.
				    if(preferencesService.prefHasUserValue("sitebar.host.sidebar.address"))
				    {
				    		var hostname = preferencesService.getCharPref("sitebar.host.sidebar.address");
				    		
				    		var sitebarCommand = hostname + "sitebar.php";
				        
				        // set frame with host option.
				        sidebarFrame.setAttribute("src", sitebarCommand);
				    }
				    else
				    {
				    		// todo: write copy default settings into options.
				    		//preferencesService.setCharPref("sitebar.host.sidebar.address", sidebarFrame.getAttribute("src"));
				    }
		    }
    }
    
    
}

function sitebar_overlayinit()
{
    const preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		var sidebarBox = document.getElementById("sidebar-box");
		var sidebar = document.getElementById("sidebar");
    	
		if (sidebarBox)
		{
				
		    // Set the width of the sidebar according the options box.
		    if(preferencesService.prefHasUserValue("sitebar.resize.sidebar.width"))
		    {
		        sidebarBox.setAttribute("width", preferencesService.getIntPref("sitebar.resize.sidebar.width"));
		    }
    }
    if (sidebar)
		{
				
		    // Set the width of the sidebar according the options box.
		    if(preferencesService.prefHasUserValue("sitebar.resize.sidebar.width"))
		    {
		        sidebar.setAttribute("width", preferencesService.getIntPref("sitebar.resize.sidebar.width"));
		    		sidebar.setAttribute("style", 'min-width: 120px; max-width: 600px;');
		    }
    }
    
		sitebar_configureKeyboardShortcuts();

}
